/* XToride, interval.c */

#include <X11/Xlib.h>
#include <stdlib.h>
#include "headers.h"

extern	Display		*d;
extern	Window		root, w;
extern	GC		gcP;
extern	Colormap	cmap;
extern	Pixmap		mountain;

extern	struct zahyou	toride[2];
extern	int		bstage[2];


/* ˤƤΰư, Ƚ, ¾֤˰¸ */
void
MoveShell(tx, ty, vx, vy, wind, mpixel, sflag)
    double		*tx, *ty, *vx, *vy, wind;
    unsigned long	mpixel;
    char		*sflag;
{
    XImage	*point;				/* POINT(x,y) ȤƻȤ */
    double	px, py;				/* Ƥκɸ */
    int		i;				/*  */

    for (i = 0; i <= 1; i++) {
	if (*(tx + i) + *(ty + i) != -2) {
	    if (bstage[i] == -1) {
		px = *(tx + i);
		py = *(ty + i);
		/* ٸΤ, ñ̻֤ RATIO */
		*(vy + i) += (GRAVITY / RATIO);
		*(vx + i) += (.05 * wind / RATIO);
		*(tx + i) += (*(vx + i) / RATIO);
		*(ty + i) += (*(vy + i) / RATIO);

		if (!(*(tx + i) < 0 || WIDTH <= *(tx + i)
					|| HEIGHT <= *(ty + i))) {
		    if (toride[i ^ 1].x <= *(tx + i)
			    && *(tx + i) < toride[i ^ 1].x + 16
			    && toride[i ^ 1].y - 8 <= *(ty + i)
			    && *(ty + i) < toride[i ^ 1].y) {	/* ̿ */
			*sflag &= 0xee;	/* ˤƼͽжػ */
			*sflag |= 0x02 << (i * 4);
			bstage[i] = 0;
			UALARM(8);
		    }
		    if (0 < *(ty + i)) {
			point = XGetImage(d, w, *(tx + i), *(ty + i), 1, 1,
					0xffffffff, XYPixmap);
			if (XGetPixel(point, 0, 0) == mpixel)	/*  */
			    bstage[i] = 0;
		    }
		}
		
		XDrawLine(d, w, gcP, px, py, *(tx + i), *(ty + i));
		XFlush(d);

		if (*(tx + i) < 0 || WIDTH <= *(tx + i)
					|| HEIGHT <= *(ty + i)) {
		    *(tx + i) = -1;
		    *(ty + i) = -1;
		}
	    } else {
		if ((*sflag & (0x02 << 4 * i)) != 0)
		    DigDug((int)*(tx + i), (int)*(ty + i),
					SPREAD * 3, bstage[i], RATIO * 5);
		else
		    DigDug((int)*(tx + i), (int)*(ty + i),
					SPREAD    , bstage[i], RATIO - 1);

		bstage[i]++;
		if (bstage[i] > 7) {
		    bstage[i] = -1;
		    *(tx + i) = -1;
		    *(ty + i) = -1;
		    if ((*sflag & 0x22) != 0  &&  bstage[i ^ 1] == -1)
			UALARM(2);	/* Ȥȯ˻Ĥäˤ */
		}
	    } /* bstage[i] == -1 */
	} /* *(tx + i) == -1 && *(ty + i) == -1 */
    } /* for (i = 0; i <= 2; i++) */
}


/* ȯ */
void
DigDug(x, y, spread, stage, rep)
    int	x, y, spread, stage, rep;
{
    XColor		tc;
    GC			gc;
    int			dx, dy;
    unsigned int	dw, dh;

    gc	= XCreateGC(d, root, 0, NULL);

    switch (stage) {
    case 0:
	tc.red = 0xffff; tc.green = 0; tc.blue = 0;
	dx = x - spread / 4;
	dy = y - spread / 4;
	dw = spread / 2;
	dh = spread / 2;
	break;
    case 1:
	tc.red = 0xffff; tc.green = 0; tc.blue = 0;
	dx = x - spread / 2;
	dy = y - spread / 2;
	dw = spread;
	dh = spread;
	break;
    case 2:
	tc.red = 0xffff; tc.green = 0; tc.blue = 0;
	dx = x - spread;
	dy = y - spread;
	dw = spread * 2;
	dh = spread * 2;
	break;
    case 3:
	tc.red = 0xffff; tc.green = 0xffff; tc.blue = 0;
	dx = x - spread;
	dy = y - spread;
	dw = spread * 2;
	dh = spread * 2;
	break;
    case 4:
	tc.red = 0xffff; tc.green = 0xffff; tc.blue = 0xffff;
	dx = x - spread;
	dy = y - spread;
	dw = spread * 2;
	dh = spread * 2;
	break;
    case 5:
	tc.red = 0; tc.green = 0x8000; tc.blue = 0xa000;
	dx = x - spread / 2;
	dy = y - spread / 2;
	dw = spread;
	dh = spread;
	break;
    case 6:
	tc.red = 0; tc.green = 0x8000; tc.blue = 0xa000;
	dx = x - spread;
	dy = y - spread;
	dw = spread * 2;
	dh = spread * 2;
	break;
    case 7:
	tc.red = 0; tc.green = 0x8000; tc.blue = 0xa000;
	XAllocColor(d, cmap, &tc);
	XSetForeground(d, gc, tc.pixel);
	XFillArc(d, mountain, gc,
		x - spread, y - spread - MHOME, spread * 2, spread * 2,
		0, 360 * 64);
	break;
    }

    if (stage < 7) {
	XAllocColor(d, cmap, &tc);
	XSetForeground(d, gc, tc.pixel);
	XFillArc(d, w, gc, dx, dy, dw, dh, 0, 360 * 64);
    }

    if (rep > 0)
	DigDug(x, y, spread, stage, rep - 1);
}
